<?php

/**
 * This is an example of queue connection configuration.
 * It will be merged into config/queue.php.
 * You need to set proper values in `.env`.
 */
return [

    'driver' => 'rabbitmq',
    'queue' => env('RABBITMQ_QUEUE', 'default'),
    'cache' => env('CACHE_DRIVER_MONITOR','apc'),
    'connection' => 'default',

    'hosts' => [
        [
            'host' => env('RABBITMQ_HOST', '127.0.0.1'),
            'port' => env('RABBITMQ_PORT', 5672),
            'user' => env('RABBITMQ_USER', 'guest'),
            'password' => env('RABBITMQ_PASSWORD', 'guest'),
            'vhost' => env('RABBITMQ_VHOST', '/'),
        ],
    ],

    'options' => [
        'queue' => [
            'job' => \Intergo\RabbitQueue\Queue\Jobs\RabbitMQJob::class,
        ],
        'keepalive' => false,
        'heartbeat' => env('RABBITMQ_HEARTBEAT', 20),
        'connectionTimeout' => env('RABBITMQ_CONNECTION_TIMEOUT',3.0),
        'readTimeout' => env('RABBITMQ_READ_TIMEOUT',3.0),
        'writeTimeout' => env('RABBITMQ_WRITE_TIMEOUT',3.0)
    ],

    /*
     * Set to "horizon" if you wish to use Laravel Horizon.
     */
    'worker' => env('RABBITMQ_WORKER', \Intergo\RabbitQueue\Queue\IntergoRabbitMQQueue::class),

];
